<!doctype html>
<html lang="ja">
<head>
  <meta charset="utf8">
  <title>Artist Finder</title>
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900|Material+Icons" rel="stylesheet">
  <link href="https://cdn.jsdelivr.net/npm/vuetify/dist/vuetify.min.css" rel="stylesheet">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=yes">
</head>
<body>
  <div id="app">
    <v-app>
      <v-toolbar app fixed scroll-toolbar-off-screen dark scroll-target="#contents">
	<v-toolbar-side-icon></v-toolbar-side-icon>
	<v-toolbar-title>Artist Finder</v-toolbar-title>
	<v-spacer></v-spacer>
	  <v-text-field v-model="searchName" label="Name" v-on:change="fetchData()"
			single-line prepend-icon="account_circle"></v-text-field>
	  <v-text-field v-model="searchPlace" label="Place"
			single-line prepend-icon="location_on"></v-text-field>
	  <v-text-field v-model="searchTag" label="tag"
			single-line prepend-icon="label"></v-text-field>
  	  <v-btn :disabled="validate"
		 color="success" v-on:click.prevent="fetchData()">SEARCH</v-btn>
      </v-toolbar>
      <div
	id="contents"
	class="scroll-y"
	style="max-height: 120%;padding-top: 50px;"
	>
	<v-container style="height: 90%">
	  <v-subheader v-if="articles.length==0">
	    {{ message }}
	  </v-subheader>
	  <eng-article v-for="(art,i) in articles" v-bind:art="art" v-bind:key="i"></eng-article>
	</v-container>
      </div>
    </v-app>
  </div>
<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vuetify/dist/vuetify.js"></script>
<script>
  new Vue({
      el: '#app',
      data: {
	  baseUrl: "https://artist-finder.shujinarazaki.now.sh/search/",
	  searchName: "",
	  searchPlace: "",
	  searchTag: "",
	  valid: false,
	  articles: [],
	  message: "Nothing to show"
      },
      computed: {
	  validate: function() {
	      return !(this.searchName || this.searchPlace || this.searchTag)
	  }
      },
      methods: {
	  fetchData: function() {
	      this.articles = [];
	      this.message = "Searching...";
	      var xhr = new XMLHttpRequest();
	      var self = this;
	      xhr.open('GET',
		       self.baseUrl
		       + "?n=" + encodeURIComponent(self.searchName)
		       + "&p=" + encodeURIComponent(self.searchPlace)
		       + "&t=" + encodeURIComponent(self.searchTag)
		      );
	      xhr.onload = function () {
		  self.articles = JSON.parse(xhr.responseText);
		  self.message = "Nothing to show";
	      };
	      xhr.send();
	  }
      }
  })
  Vue.component('eng-article', {
      props: ['art'],
      template: '<v-hover><v-card light slot-scope="{ hover }" :class="`elevation-${hover ? 12 : 2}`" class="mx-auto" style="margin-top:6px;"><v-card-title primary-title><div><div class="headline">{{art.name}}</div><div class="grey--text">in {{art.place}}, rating: {{art.rating_point}} by {{art.rating_count}}</div></div></v-card-title><v-card-text><span v-for="(alias,i) in art.aliases" v-bind:key="i">{{alias}}&ensp;</span></v-card-text><v-card-actions><v-btn v-for="(tag,i) in art.tags" flat color="orange" v-bind:key="i">{{tag}}</v-btn></v-card-actions></v-card></v-hover>'
  })
</script>
</body>
</html>
